var $ = jQuery;
$(function() {

// Поиск студентов
function AddStudent(ID, Name, From, GroupID, Bind){
	if (Bind == true)
		var Status = 'StatusBind';
	else 
		var Status = 'StatusUnbind';
	var r = '\
		<div id="'+ ID +'" class="Student '+ Status +' '+ GroupID +'">\
			<span class="Name">'+ Name +'</span> \
			<span class="From">'+ From +'</span>';
	if (Bind == true)
		r +='<button class="action Action_UnbindStudent">Отсоединить студента</button>';
	else
		r +='<button class="action Action_BindStudent">Прикрепить студента</button>';
	r +=
		'</div>';
	return r;
}

function AddStudentInSearchBox(ID, Name, From, GroupID, Bind){
	if (Bind == true)
		var Status = 'StatusBind';
	else 
		var Status = 'StatusUnbind';
	var r = '\
		<div id="'+ ID +'" class="Student '+ Status +' '+ GroupID +'">\
			<span class="Name">'+ Name +'</span> \
			<span class="From">'+ From +'</span>';
	if (Bind == true)
		r +='<button class="action Action_UnbindStudent">Отсоединить студента</button>';
	else
		r +='<button class="action Action_BindStudentFromSearch">Прикрепить студента</button>';
	r +=
		'</div>';
	return r;
}

// Поиск студентов
function CallSearchStudents() 
{
	var Name = [];
	if ($('.InputStudentName').val().length > 0)
		Name = ($('.InputStudentName').val()).split(' ');
	$.post(
		URLdir + 'handler/map/SearchStudents',
		{
			'GradeID': $('.SelectGrade').val(),
			'GroupN': $('.SelectStudyGroup').val(),
			'FacultyID': FacultyID,
			'Last': Name[0],
			'First': Name[1],
			'Second': Name[2],
			'DisciplineID': DisciplineID
		},
		function(SearchResult){
			var SearchResult = $.parseJSON(SearchResult);
			var jSearch = $('.SearchResult').first();
			var i = 0;
			var data = '';
			$('.SearchResult').html('');
			for(i in SearchResult) 
			{
				var ID = SearchResult[i].ID;
				var Name = SearchResult[i].LastName +' '+  SearchResult[i].FirstName +' '+ SearchResult[i].SecondName;
				var From = 'Курс ' + SearchResult[i].GradeNum + ', Группа ' + SearchResult[i].GroupNum;
				var GroupID = 'GroupID_'+SearchResult[i].GroupID;
				data += AddStudentInSearchBox(ID, Name, From, GroupID, false);
			}
			if (i <= 0)
				jSearch.html('<p class="notification">Нет результатов... Возможно, студенты, соответствующие критериям поиска, уже прикреплены.</p>');
			else jSearch.html($.parseHTML(data));
		}
	);	
}

$('.SelectGrade').change(function(){
	$.post(
		URLdir + 'handler/map/GetStudyGroups',
		{
			'FacultyID': FacultyID,
			'GradeID': $(this).val()
		},
		function(data){
			data = $.parseJSON(data);
			var i = 0;
			if (data != null && data != undefined) {
				$('.SelectStudyGroup').html('<option value="0">Выберите группу:</option>');
				for (i in data) {
					$('.SelectStudyGroup').append('<option value="'+ data[i].GroupID +'">Группа '+ data[i].GroupNum +' - '+ data[i].SpecName +'</option>');
				}	
			}
			if (i <= 0)
				$('.SelectStudyGroup').html('<option value="0">Нет групп</option>');	
			CallSearchStudents();
		}
	);
});
$('.SelectStudyGroup').change(function(){
	CallSearchStudents();
});
$('.InputStudentName').focusout(function(){
	CallSearchStudents();
});
$('.InputStudentName').keydown(function(e){
	if(e.keyCode==13){
		$(this).focusout('focusout');
		$(this).blur();
	}
});

$('.SelectGrade').focusout(function(){
	$(this).trigger('change');
});


$('.SelectStudyGroup').focusout(function(){
	$(this).trigger('change');
});

// Если студент из поиска
function BindStudentFromSearch(thisObj) 
{
	var reg = /GroupID_\d+/;
	var GroupID = ''+reg.exec(thisObj.parent().attr('class'));
	var ID = thisObj.parent().attr('id');
	var Name = thisObj.siblings('.Name').text();
	var From = thisObj.siblings('.From').text();
	if ($('div').is('.GroupContainer.'+GroupID) === false) {
		$('.AttachedStudentsList').append('\
			<div class="GradeAndGroupTitle ActionShowHideGroupContainer">\
			<span class="info">'+From+'</span>\
			<span class="Action">Открыть список ▼</span>\
		</div>');
		$('.AttachedStudentsList').append('<div class="GroupContainer '+GroupID+'" style="display: block"> </div>');
	}
	$('.GroupContainer.'+GroupID).append(AddStudent(ID, Name, From, GroupID, true));
	thisObj.parent().remove();
}

// Если студент из основного потока
function BindBackStudent(thisObj) {
	thisObj
		.removeClass('Action_BindStudent')
		.addClass('Action_UnbindStudent')
		.text('Отсоединить студента');
	thisObj
		.parent()
		.removeClass('StatusUnbind')
		.addClass('StatusBind');
}

// Прикрепить студента 
$('.StudentsList').on('click', 'button.Action_BindStudent', function(){
	var thisObj = $(this);
	$(this).attr("disabled", true);
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/BindStudent',
		{
			'StudentID': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				BindBackStudent(thisObj);
				EventInspector_ShowMsg('Студент добавлен', 'success');
			}
			else EventInspector_ShowMsg('Ошибка при добавление студента', 'error');
			thisObj.removeAttr('disabled');
		}
	);
});

// Прикрепить студента из поиска
$('.StudentsList').on('click', 'button.Action_BindStudentFromSearch', function(){
	var thisObj = $(this);
	$(this).attr("disabled", true);
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/BindStudent',
		{
			'StudentID': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				BindStudentFromSearch(thisObj);
				EventInspector_ShowMsg('Студент добавлен', 'success');
				//thisObj.remove();
			}
			else EventInspector_ShowMsg('Ошибка при добавление студента', 'error');
			thisObj.removeAttr('disabled');
		}
	);
});

// Отсоединить студента 
$('.StudentsList').on('click', 'button.Action_UnbindStudent', function(){
	var thisObj = $(this);
	$(this).attr("disabled", true);
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/UnbindStudent',
		{
			'StudentID': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				thisObj
					.removeClass('Action_UnbindStudent')
					.addClass('Action_BindStudent')
					.text('Прикрепить студента');
				thisObj
					.parent()
					.removeClass('StatusBind')
					.addClass('StatusUnbind');
				EventInspector_ShowMsg('Студент отсоединен', 'success');
			}
			else EventInspector_ShowMsg('Ошибка при отсоединение студента', 'error');
			thisObj.removeAttr('disabled');
		}
	);
});

// Показать/скрыть список студентов
$('.StudentsList').on('click', '.ActionShowHideGroupContainer', function(){
	var GroupContainer = $(this).next('.GroupContainer');
	if (GroupContainer.css('display') == 'none') {
		$(this).children('.Action').text('Скрыть список ▲');
		GroupContainer.show();
		GroupContainer.css('height', GroupContainer.height());
	}
	else {
		$(this).children('.Action').text('Открыть список ▼');
		GroupContainer.hide('normal');
	}
});

$('.StudentsList').on('click', '.hideListAction', function(){
	$(this).parent()
		.hide('normal');
		
	$(this).parent()
		.prev()
		.children('.Action')
		.text('Открыть список ▼');
});



});